
#include <stdio.h>
#include <tiffio.h>

int main(int argc, char **argv)
{
    if (argc <= 1)
    {
        printf("need file name\n");
        return 0;
    }
    
    const int dim = 64;
    const int channels = 3;
    const int size = dim * dim * channels;
    char *buf = malloc(size);
    int i = 0;
    for (i = 0; i < size; i++)
        buf[i] = '\0';
    
    TIFF *tif = TIFFOpen(argv[1], "w");
    if (tif == NULL)
        printf("can't open file to write\n");
    else
    {
        TIFFSetField(tif, TIFFTAG_IMAGEWIDTH,      dim);
        TIFFSetField(tif, TIFFTAG_IMAGELENGTH,     dim);
        TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, channels);
        TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP,    1);
        TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE,   8);
        TIFFSetField(tif, TIFFTAG_PLANARCONFIG,    1);
        TIFFSetField(tif, TIFFTAG_PHOTOMETRIC,     PHOTOMETRIC_RGB);
        TIFFSetField(tif, TIFFTAG_COMPRESSION,     COMPRESSION_LZW);
        
        int err = 0;
        for (i = 0; i < dim; i++)
        {
            if (TIFFWriteScanline(tif, buf + dim*channels*(dim - i - 1), i, 0) != 1)
                err = -1;
        }

        if (TIFFWriteDirectory(tif) != 1)
            err = -1;
        
        if (err != 0)
            printf("error\n");
            
        TIFFClose(tif);
    }
        
    free(buf);
    return 0;
}
